/* Questo sketch disegna una sfera che si muove rimbalzando sul 
terreno. La sfera rimbalza anche quando arriva a impattare sulle 
pareti laterali. Con un click di mouse si può modificare la
posizione della sfera. La sfera cambia colore casualmente ad ogni 
rimbalzo laterale. Il numero di rimbalzi viene contato e 
visualizzato. La soluzione proposta è robusta rispetto ad errori 
di misura della posizione x della sfera (scommentare la riga 42
per verificarlo) */

float x = 0;
float y = 100;
float vX = 10; // la velocità orizzontale
float vY = -10; // la velocità verticale
float diametro = 50;
float verso = 1;
float limite;
int conta = 0;
int colA = 0;
int colB = 255;
int colC = 255;
float xMisurato;
float erroreMisura = 0;

void setup() 
{
  size(1200, 700);
  smooth();
  fill(colA,colB,colC);
  limite = width-diametro/2;
}

void draw() 
{
  background(204);
  if (mousePressed)
  {
    x = mouseX;
    y = mouseY;
  }

// Scommentare la seguente riga per testare il codice in presenza di un errore di misura sulla x
  //erroreMisura = round(random(-100,100));
  xMisurato = x + erroreMisura;
  if (verso*xMisurato > limite)
  {
    colA = round(random(255));
    colB = round(random(255));
    colC = round(random(255));
    fill(colA,colB,colC);
    
    vX = - vX;
    verso = -verso;
    if (verso == -1)
    {
      limite = -diametro/2;
    }
    else
    {
      limite = width - diametro/2;
    }
    conta++;
  }
  x = x+vX;
  if (y < height-diametro/2)
  {
    vY = vY + 1;    
  }
  else
  {
    vY = - vY;
  }
  y = y + vY;  

  
  fill(colA,colB,colC);
  ellipse(x, y, diametro, diametro);
  textSize(30);
  fill(0);
  text(conta,50,50);
}