/* Questo sketch disegna una sfera che si muove rimbalzando verso 
destra. Posizione e velocità iniziale sono casuali. Non prevede 
possibilità di interazione con l'utente. */

float x = 0; // coordinata x della sfera
float y = 100; // coordinata y della sfera
float vX = 10; // velocità orizzontale sfera
float vY = -10; // velocità verticale sfera
float diametro = 50; // diametro sfera

void setup() 
{
  size(600, 400);
  smooth();
  fill(102);
}

void draw() 
{
  background(204); // disegna sfondo con livello di grigio 204
  if (x<width+diametro/2) // la sfera non è ancora arrivata all'estrema destra della finestra
  {
    x = x+vX; // la sfera avanza verso destra
    if (y < height-diametro/2) // la sfera non ha ancora toccato terra
    {
      vY = vY + 1;    // aumento velocità verticale per accelerazione di gravità
    }
    else // la sfera tocca terra
    {
      vY = - vY; // rimbalzo
    }
    y = y + vY;  // aggiornamento posizione verticale
  }
  else // la sfera ha raggiunto l'estremità destra della finestra
  {
    x = -diametro/2;  // ricompare a sinistra
    y = random(10,height-diametro); // ricompare da un'altezza casuale
    vX = random(3,15); // con una velocità orizzontale casuale
    vY = random(-5,10); // e con una velocità verticale casuale
  }
  ellipse(x, y, diametro, diametro); // disegno la sfera
}