/* Questo sketch implementa un contatore che viene incrementato mentre si 
preme il mouse e viene riazzerato quando il mouse viene rilasciato.
Il valore del contatore viene visualizzato sullo schermo. */

int contaPrec = 0; // valore precedente del contatore
int conta = 0; // valore attuale del contatore

void setup() 
{
  size(300, 200);
}

void draw() 
{
  
  background(204); // disegna sfondo con livello di grigio 204
  
  if (mousePressed) // se il mouse è premuto
  {
    conta++; // incremento il contatore
  }
  else // se il tasto non è premuto...
  {
    if (conta > 0) // ... ma il conteggio è positivo (cioè il tasto è stato appena rilasciato) 
    {
      contaPrec = conta; // memorizzo il valore raggiunto
      conta = 0; // e riazzero il contatore
    }
  }
  
  // Scrivo il valore del contatore (precedente e nuovo) sullo schermo
  textSize(30);
  fill(0);
  text(contaPrec,50,50);
  fill(200,100,70);
  text(conta,150,50);
}